% find_d function to find GMM d matrix
function d = find_d(lambdas,phistar, mustar,delta0, delta1,qr,A,B,X,V,rx,wts);

    T = size(X,1);
    x = X(:,1); 
    
    Ex = mean(x(1:T-12));
    EX = mean(X(1:T-12,:))';
    
    % construct regression elements -- taken straight from findg.m
    d1 =  [    1           Ex             ; 
           mean(X(1:T-12,:))' mean((x(1:T-12)*ones(1,4)).*X(1:T-12,:))'] ;
    d =  [kron(d1,qr'*B(1:14,:)*V(:,2))];
    d = -d; 
      
    
    % now on to mean moment
    lam1 = [ [ 0 lambdas(2) 0 0]' zeros(4,3)]; % pad out to usual matrix size
    phi = phistar + V*lam1;
    mu = mustar + V(:,2)*lambdas(1);
    
    maxeig = max(max(abs(eig(phi))));
    if maxeig >= 1
        fprintf('ERROR in find_d: eig(phi)>1 eig = %15.7g \n',meaxeig);
    end;
    
    EXpred = inv(eye(4)-phi)*mu;
    Expred = EXpred(1);
    d = [d; -kron( [1 Expred],inv(eye(4)-phi)*V(:,2))];;
    