
    function gT = findg(lambdas,phistar, mustar,delta0, delta1,qr,A,B,X,V,rx);
    
    T = size(X,1);
    x = X(:,1); 
    
    Ex = mean(x(1:T-12));
    EX = mean(X(1:T-12,:))';
    
    % construct regression moments
    d1 =  [    1           Ex             ; 
           mean(X(1:T-12,:))' mean((x(1:T-12)*ones(1,4)).*X(1:T-12,:))'] ;
    d =  [kron(d1,qr'*B(1:14,:)*V(:,2))];
      
    BVB = zeros(14,1);
    for i = 1:14; 
        BVB(i) = B(i,:)*V*B(i,:)';% BVB(1) corresponds to rx(2)
    end;
     
    C = [ (mean(rx(13:T,:))*qr  + 1/2*qr'*BVB);
          (mean( (rx(13:T,:)*qr)*ones(1,4) .* X(1:T-12,:))'  + 1/2*qr'*BVB*EX)];

    gT = C - d*lambdas; 
    
    % now on to mean moment
    lam1 = [ [ 0 lambdas(2) 0 0]' zeros(4,3)]; % pad out to usual matrix size
    phi = phistar + V*lam1;
    mu = mustar + V(:,2)*lambdas(1);
    
    maxeig = max(max(abs(eig(phi))));
    if maxeig >= 1
        %fprintf('ERROR findg. eig(phi)>1 lambda= %8.3f %8.3f, eig = %15.7g \n',lambdas,maxeig);
        gT = NaN*ones(9,1);
    else;
        gT = [gT; mean(X)' - inv(eye(4)-phi)*mu ];
    end;
    