% decodes vector passed to minobj 
% passing parameters to minobj. 

% subs and which are full length. minpars only contains elements where
% which == 1. 

function [ mustar phistar delt0 delt1 ] = decode_level(minpars,which,subs,demean)

%need reprogramming if you want to try 3 factor model.

minpar_index = 1; 
which_index = 1; 
if ~demean
    mustar = zeros(4,1); 
    for i = 1:4
        if which(which_index) == 1;  
            mustar(i) = minpars(minpar_index);
            minpar_index = minpar_index+1;
        else
            mustar(i) = subs(which_index); 
        end;
        which_index = which_index+1;
    end;
end
if demean
    if which(1) == 1; 
        mustar = minpars(1); % passed back as mustar even though it's really lambda0l
        minpar_index = minpar_index+1;
    else
        mustar = subs(1);
    end
    which_index = which_index+1;
end;

phistar = zeros(4,4);
for i = 1:16; 
    if which(which_index) == 1;
        phistar(i)=minpars(minpar_index);
        minpar_index = minpar_index+1;
    else;
        phistar(i)=subs(which_index)
    end
    which_index = which_index+1;
end

if which(which_index) == 1; 
    delt0 = minpars(minpar_index);
    minpar_index = minpar_index+1;
 else
    delt0 = subs(which_index); 
end;
which_index = which_index+1;

delt1 = zeros(4,1);
for i = 1:4;
    if which(which_index) == 1; 
        delt1(i) = minpars(minpar_index);
        minpar_index=minpar_index+1;
    else
        delt1(i) = subs(which_index);
    end
    which_index = which_index+1;
end

% I used to allow an option to force y^1 = regression loadings. Searching
% for delta seems to be working though so why not. 
%else;
%    delt0 = a(1); 
%    delt1 = b(1,:)';
%end;
